---
title: Detect Abbreviations in Form Entries
product: Form Library
description: Detect, validate, and expand abbreviations in SurveyJS forms using a terminology dictionary. View this JavaScript demo to learn more.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Detect Abbreviations in Form Entries (Vanilla JS)

Abbreviation detection recognizes shortened forms, acronyms, and shorthand in entered text, then expands them, suggests a full term, or flags ambiguous usage. Examples include `BP` → Blood Pressure, `NYC` → New York City, and `MS`, which can have multiple meanings in clinical settings.

To detect abbreviations in SurveyJS, register a [custom asynchronous function](/form-library/documentation/design-survey/conditional-logic#asynchronous-functions) and add async expression validators to a question's [`validators`](/form-library/documentation/api-reference/question#validators) array. You can also expand recognized abbreviations in the [`onValueChanged`](/form-library/documentation/survey-data-model#onValueChanged) event handler.

## How This Demo Works

1. An in-demo terminology dictionary simulates a reference data source.
2. Common department abbreviations expand automatically (for example, `HR` becomes `Human Resources`).
3. Other fields use async expression validators that call the `isAbbreviationAcceptable` function.
4. If an abbreviation issue is detected, the function returns `false`, and the field displays the validator [`text`](/form-library/documentation/api-reference/textvalidator#text).

In this demo, validators use [`"notificationType": "warning"`](/form-library/documentation/api-reference/textvalidator#notificationType), so validation messages do not block form submission. To prevent the form from being submitted until the issue is resolved, use the default `"error"` notification type.

[Validator Notification Types](/survey-creator/documentation/end-user-guide/data-validation-in-forms#validator-notification-types (linkStyle))

## Connect to an API Endpoint

To validate against a terminology service, dictionary, or natural language processing (NLP) endpoint, replace the demo helper with a `fetch` call (or an equivalent call using your SDK). Keep the same `registerFunction` and expression validator:

```js
function isAbbreviationAcceptable([fieldName, value]) {
  if (!value) {
    this.returnResult(true);
    return;
  }
  fetch("/api/validation/abbreviations", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({ fieldName, value })
  })
    .then((response) => response.json())
    .then((data) => {
      // data.ok === true means the value is acceptable
      this.returnResult(!!data.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isAbbreviationAcceptable",
  func: isAbbreviationAcceptable,
  isAsync: true
});
```

Add expression validators to your survey JSON, for example: `"expression": "isAbbreviationAcceptable('location', {location})"`. Refer to the JSON schema in the Code tab for more examples.

## Related Demos

- [Server-Side Form Validation Using Expressions](/form-library/examples/javascript-async-form-validation/)
- [Server-Side Form Validation Using an Event](/form-library/examples/javascript-server-side-form-validation/)
- [Detect Mis-Keyed Form Entries](/form-library/examples/detect-miskeyed-form-entries/)
- [Detect Duplicate Form Records](/form-library/examples/detect-duplicate-form-records/)

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { registerFunction } from "survey-core";


// Async expression validators + client-side auto-expand for safe abbreviations.
// Demo uses an in-memory dictionary; see the Documentation tab to connect your own API.

const ABBREVIATION_DICTIONARY = [
  { abbr: "BP", expansion: "Blood Pressure", autoExpand: false },
  { abbr: "DOB", expansion: "Date of Birth", autoExpand: false },
  { abbr: "Rx", expansion: "Prescription", autoExpand: false },
  { abbr: "Dx", expansion: "Diagnosis", autoExpand: false },
  { abbr: "HTN", expansion: "Hypertension", autoExpand: false },
  { abbr: "NYC", expansion: "New York City", autoExpand: false },
  { abbr: "Dept", expansion: "Department", autoExpand: true },
  { abbr: "HR", expansion: "Human Resources", autoExpand: true },
  { abbr: "Qty", expansion: "Quantity", autoExpand: true },
  { abbr: "approx", expansion: "approximately", autoExpand: false },
  { abbr: "approx.", expansion: "approximately", autoExpand: false },
  { abbr: "Intl", expansion: "International", autoExpand: false },
  { abbr: "ECG", expansion: "Electrocardiogram", autoExpand: false },
  {
    abbr: "MS",
    expansion: null,
    doNotUse: true,
    meanings: ["Multiple Sclerosis", "Morphine Sulfate", "Mitral Stenosis"]
  }
];

function normalizeToken(token) {
  return String(token || "").trim();
}

function dictionaryKey(abbr) {
  return normalizeToken(abbr).replace(/\.$/, "").toLowerCase();
}

function findDictionaryEntry(token) {
  const raw = normalizeToken(token);
  if (!raw) return null;
  const key = dictionaryKey(raw);
  return ABBREVIATION_DICTIONARY.find((entry) => {
    return dictionaryKey(entry.abbr) === key ||
      normalizeToken(entry.abbr).toLowerCase() === raw.toLowerCase();
  }) || null;
}

function extractTokens(text) {
  return String(text || "")
    .split(/[\s,;:/]+/)
    .map(normalizeToken)
    .filter(Boolean);
}

function findAbbreviationsInText(text) {
  const found = [];
  const seen = {};

  extractTokens(text).forEach((token) => {
    const entry = findDictionaryEntry(token);
    if (!entry) return;
    const key = dictionaryKey(entry.abbr);
    if (seen[key]) return;
    seen[key] = true;
    found.push(entry);
  });

  const whole = findDictionaryEntry(text);
  if (whole && !seen[dictionaryKey(whole.abbr)]) {
    found.push(whole);
  }

  return found;
}

function fieldHasAbbreviationIssue(name, value) {
  if (!value) return false;

  if (name !== "clinicalNotes") {
    const exact = findDictionaryEntry(value);
    if (exact) {
      if (exact.doNotUse) return true;
      if (exact.autoExpand && name === "department") return false;
      if (exact.expansion) return true;
    }
  }

  const matches = findAbbreviationsInText(value);
  if (!matches.length) return false;
  if (matches.some((entry) => entry.doNotUse)) return true;
  if (name === "clinicalNotes") {
    return matches.some((entry) => entry.expansion);
  }
  return !!matches[0].expansion;
}

// In-demo async check (replace with fetch to your terminology API in production).
function mockValidationApi(fieldName, value) {
  return new Promise((resolve) => {
    setTimeout(() => {
      resolve({ ok: !fieldHasAbbreviationIssue(fieldName, value) });
    }, 450);
  });
}

// Expression validator: returns true when the value is clear of abbreviation issues.
function isAbbreviationAcceptable([fieldName, value]) {
  if (!value) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(fieldName, value)
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isAbbreviationAcceptable",
  func: isAbbreviationAcceptable,
  isAsync: true
});

function autoExpandAbbreviations(sender, options) {
  if (options.name !== "department") {
    return;
  }

  const entry = findDictionaryEntry(options.value);
  if (!entry || !entry.autoExpand || !entry.expansion) {
    return;
  }

  if (normalizeToken(options.value).toLowerCase() === entry.expansion.toLowerCase()) {
    return;
  }

  sender.setValue(options.name, entry.expansion);
}

const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.onValueChanged.add(autoExpandAbbreviations);

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Clinical Intake",
  "description": "Try abbreviations such as HR, NYC, BP, approx., or MS. Safe department terms auto-expand as you type; other fields use async expression validators against a terminology dictionary.",
  "checkErrorsMode": "onValueChanged",
  "completeText": "Submit Intake",
  "pages": [
    {
      "name": "intake",
      "elements": [
        {
          "type": "text",
          "name": "department",
          "title": "Department",
          "description": "Safe business abbreviations auto-expand as you type (try HR or Dept).",
          "placeholder": "e.g. HR"
        },
        {
          "type": "text",
          "name": "location",
          "title": "Clinic location",
          "description": "Known place abbreviations are checked via an async expression validator (try NYC).",
          "placeholder": "e.g. NYC",
          "validators": [
            {
              "type": "expression",
              "text": "This looks like an abbreviation. Prefer the full place name (for example, New York City instead of NYC).",
              "expression": "isAbbreviationAcceptable('location', {location})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "comment",
          "name": "clinicalNotes",
          "title": "Clinical notes",
          "description": "Free-text abbreviations are detected asynchronously (try \"BP elevated\" or \"Dx: HTN\").",
          "placeholder": "e.g. BP elevated; Dx: HTN; Rx pending",
          "validators": [
            {
              "type": "expression",
              "text": "Abbreviations detected in the notes. Prefer full terminology (for example, Blood Pressure instead of BP).",
              "expression": "isAbbreviationAcceptable('clinicalNotes', {clinicalNotes})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "text",
          "name": "condition",
          "title": "Primary condition / code",
          "description": "Ambiguous or Do Not Use abbreviations are flagged (try \"MS\").",
          "placeholder": "e.g. MS",
          "validators": [
            {
              "type": "expression",
              "text": "This abbreviation is ambiguous or on a Do Not Use list (for example, MS). Enter the full approved term.",
              "expression": "isAbbreviationAcceptable('condition', {condition})",
              "notificationType": "warning"
            }
          ]
        }
      ]
    }
  ]
}
;
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/angular.md)
- [React](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/jquery.md)


---
title: Detect Abbreviations in Form Entries
product: Form Library
description: Detect, validate, and expand abbreviations in SurveyJS forms using a terminology dictionary. View this JavaScript demo to learn more.
framework: React
source: https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Detect Abbreviations in Form Entries (React)

Abbreviation detection recognizes shortened forms, acronyms, and shorthand in entered text, then expands them, suggests a full term, or flags ambiguous usage. Examples include `BP` → Blood Pressure, `NYC` → New York City, and `MS`, which can have multiple meanings in clinical settings.

To detect abbreviations in SurveyJS, register a [custom asynchronous function](/form-library/documentation/design-survey/conditional-logic#asynchronous-functions) and add async expression validators to a question's [`validators`](/form-library/documentation/api-reference/question#validators) array. You can also expand recognized abbreviations in the [`onValueChanged`](/form-library/documentation/survey-data-model#onValueChanged) event handler.

## How This Demo Works

1. An in-demo terminology dictionary simulates a reference data source.
2. Common department abbreviations expand automatically (for example, `HR` becomes `Human Resources`).
3. Other fields use async expression validators that call the `isAbbreviationAcceptable` function.
4. If an abbreviation issue is detected, the function returns `false`, and the field displays the validator [`text`](/form-library/documentation/api-reference/textvalidator#text).

In this demo, validators use [`"notificationType": "warning"`](/form-library/documentation/api-reference/textvalidator#notificationType), so validation messages do not block form submission. To prevent the form from being submitted until the issue is resolved, use the default `"error"` notification type.

[Validator Notification Types](/survey-creator/documentation/end-user-guide/data-validation-in-forms#validator-notification-types (linkStyle))

## Connect to an API Endpoint

To validate against a terminology service, dictionary, or natural language processing (NLP) endpoint, replace the demo helper with a `fetch` call (or an equivalent call using your SDK). Keep the same `registerFunction` and expression validator:

```js
function isAbbreviationAcceptable([fieldName, value]) {
  if (!value) {
    this.returnResult(true);
    return;
  }
  fetch("/api/validation/abbreviations", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({ fieldName, value })
  })
    .then((response) => response.json())
    .then((data) => {
      // data.ok === true means the value is acceptable
      this.returnResult(!!data.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isAbbreviationAcceptable",
  func: isAbbreviationAcceptable,
  isAsync: true
});
```

Add expression validators to your survey JSON, for example: `"expression": "isAbbreviationAcceptable('location', {location})"`. Refer to the JSON schema in the Code tab for more examples.

## Related Demos

- [Server-Side Form Validation Using Expressions](/form-library/examples/javascript-async-form-validation/)
- [Server-Side Form Validation Using an Event](/form-library/examples/javascript-server-side-form-validation/)
- [Detect Mis-Keyed Form Entries](/form-library/examples/detect-miskeyed-form-entries/)
- [Detect Duplicate Form Records](/form-library/examples/detect-duplicate-form-records/)

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";
import { registerFunction } from "survey-core";


// Async expression validators + client-side auto-expand for safe abbreviations.
// Demo uses an in-memory dictionary; see the Documentation tab to connect your own API.

const ABBREVIATION_DICTIONARY = [
  { abbr: "BP", expansion: "Blood Pressure", autoExpand: false },
  { abbr: "DOB", expansion: "Date of Birth", autoExpand: false },
  { abbr: "Rx", expansion: "Prescription", autoExpand: false },
  { abbr: "Dx", expansion: "Diagnosis", autoExpand: false },
  { abbr: "HTN", expansion: "Hypertension", autoExpand: false },
  { abbr: "NYC", expansion: "New York City", autoExpand: false },
  { abbr: "Dept", expansion: "Department", autoExpand: true },
  { abbr: "HR", expansion: "Human Resources", autoExpand: true },
  { abbr: "Qty", expansion: "Quantity", autoExpand: true },
  { abbr: "approx", expansion: "approximately", autoExpand: false },
  { abbr: "approx.", expansion: "approximately", autoExpand: false },
  { abbr: "Intl", expansion: "International", autoExpand: false },
  { abbr: "ECG", expansion: "Electrocardiogram", autoExpand: false },
  {
    abbr: "MS",
    expansion: null,
    doNotUse: true,
    meanings: ["Multiple Sclerosis", "Morphine Sulfate", "Mitral Stenosis"]
  }
];

function normalizeToken(token) {
  return String(token || "").trim();
}

function dictionaryKey(abbr) {
  return normalizeToken(abbr).replace(/\.$/, "").toLowerCase();
}

function findDictionaryEntry(token) {
  const raw = normalizeToken(token);
  if (!raw) return null;
  const key = dictionaryKey(raw);
  return ABBREVIATION_DICTIONARY.find((entry) => {
    return dictionaryKey(entry.abbr) === key ||
      normalizeToken(entry.abbr).toLowerCase() === raw.toLowerCase();
  }) || null;
}

function extractTokens(text) {
  return String(text || "")
    .split(/[\s,;:/]+/)
    .map(normalizeToken)
    .filter(Boolean);
}

function findAbbreviationsInText(text) {
  const found = [];
  const seen = {};

  extractTokens(text).forEach((token) => {
    const entry = findDictionaryEntry(token);
    if (!entry) return;
    const key = dictionaryKey(entry.abbr);
    if (seen[key]) return;
    seen[key] = true;
    found.push(entry);
  });

  const whole = findDictionaryEntry(text);
  if (whole && !seen[dictionaryKey(whole.abbr)]) {
    found.push(whole);
  }

  return found;
}

function fieldHasAbbreviationIssue(name, value) {
  if (!value) return false;

  if (name !== "clinicalNotes") {
    const exact = findDictionaryEntry(value);
    if (exact) {
      if (exact.doNotUse) return true;
      if (exact.autoExpand && name === "department") return false;
      if (exact.expansion) return true;
    }
  }

  const matches = findAbbreviationsInText(value);
  if (!matches.length) return false;
  if (matches.some((entry) => entry.doNotUse)) return true;
  if (name === "clinicalNotes") {
    return matches.some((entry) => entry.expansion);
  }
  return !!matches[0].expansion;
}

// In-demo async check (replace with fetch to your terminology API in production).
function mockValidationApi(fieldName, value) {
  return new Promise((resolve) => {
    setTimeout(() => {
      resolve({ ok: !fieldHasAbbreviationIssue(fieldName, value) });
    }, 450);
  });
}

// Expression validator: returns true when the value is clear of abbreviation issues.
function isAbbreviationAcceptable([fieldName, value]) {
  if (!value) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(fieldName, value)
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isAbbreviationAcceptable",
  func: isAbbreviationAcceptable,
  isAsync: true
});

function autoExpandAbbreviations(sender, options) {
  if (options.name !== "department") {
    return;
  }

  const entry = findDictionaryEntry(options.value);
  if (!entry || !entry.autoExpand || !entry.expansion) {
    return;
  }

  if (normalizeToken(options.value).toLowerCase() === entry.expansion.toLowerCase()) {
    return;
  }

  sender.setValue(options.name, entry.expansion);
}

function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.onValueChanged.add(autoExpandAbbreviations);
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Clinical Intake",
  "description": "Try abbreviations such as HR, NYC, BP, approx., or MS. Safe department terms auto-expand as you type; other fields use async expression validators against a terminology dictionary.",
  "checkErrorsMode": "onValueChanged",
  "completeText": "Submit Intake",
  "pages": [
    {
      "name": "intake",
      "elements": [
        {
          "type": "text",
          "name": "department",
          "title": "Department",
          "description": "Safe business abbreviations auto-expand as you type (try HR or Dept).",
          "placeholder": "e.g. HR"
        },
        {
          "type": "text",
          "name": "location",
          "title": "Clinic location",
          "description": "Known place abbreviations are checked via an async expression validator (try NYC).",
          "placeholder": "e.g. NYC",
          "validators": [
            {
              "type": "expression",
              "text": "This looks like an abbreviation. Prefer the full place name (for example, New York City instead of NYC).",
              "expression": "isAbbreviationAcceptable('location', {location})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "comment",
          "name": "clinicalNotes",
          "title": "Clinical notes",
          "description": "Free-text abbreviations are detected asynchronously (try \"BP elevated\" or \"Dx: HTN\").",
          "placeholder": "e.g. BP elevated; Dx: HTN; Rx pending",
          "validators": [
            {
              "type": "expression",
              "text": "Abbreviations detected in the notes. Prefer full terminology (for example, Blood Pressure instead of BP).",
              "expression": "isAbbreviationAcceptable('clinicalNotes', {clinicalNotes})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "text",
          "name": "condition",
          "title": "Primary condition / code",
          "description": "Ambiguous or Do Not Use abbreviations are flagged (try \"MS\").",
          "placeholder": "e.g. MS",
          "validators": [
            {
              "type": "expression",
              "text": "This abbreviation is ambiguous or on a Do Not Use list (for example, MS). Enter the full approved term.",
              "expression": "isAbbreviationAcceptable('condition', {condition})",
              "notificationType": "warning"
            }
          ]
        }
      ]
    }
  ]
}
;
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/vanillajs.md)


---
title: Detect Abbreviations in Form Entries
product: Form Library
description: Detect, validate, and expand abbreviations in SurveyJS forms using a terminology dictionary. View this JavaScript demo to learn more.
framework: Angular
source: https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Detect Abbreviations in Form Entries (Angular)

Abbreviation detection recognizes shortened forms, acronyms, and shorthand in entered text, then expands them, suggests a full term, or flags ambiguous usage. Examples include `BP` → Blood Pressure, `NYC` → New York City, and `MS`, which can have multiple meanings in clinical settings.

To detect abbreviations in SurveyJS, register a [custom asynchronous function](/form-library/documentation/design-survey/conditional-logic#asynchronous-functions) and add async expression validators to a question's [`validators`](/form-library/documentation/api-reference/question#validators) array. You can also expand recognized abbreviations in the [`onValueChanged`](/form-library/documentation/survey-data-model#onValueChanged) event handler.

## How This Demo Works

1. An in-demo terminology dictionary simulates a reference data source.
2. Common department abbreviations expand automatically (for example, `HR` becomes `Human Resources`).
3. Other fields use async expression validators that call the `isAbbreviationAcceptable` function.
4. If an abbreviation issue is detected, the function returns `false`, and the field displays the validator [`text`](/form-library/documentation/api-reference/textvalidator#text).

In this demo, validators use [`"notificationType": "warning"`](/form-library/documentation/api-reference/textvalidator#notificationType), so validation messages do not block form submission. To prevent the form from being submitted until the issue is resolved, use the default `"error"` notification type.

[Validator Notification Types](/survey-creator/documentation/end-user-guide/data-validation-in-forms#validator-notification-types (linkStyle))

## Connect to an API Endpoint

To validate against a terminology service, dictionary, or natural language processing (NLP) endpoint, replace the demo helper with a `fetch` call (or an equivalent call using your SDK). Keep the same `registerFunction` and expression validator:

```js
function isAbbreviationAcceptable([fieldName, value]) {
  if (!value) {
    this.returnResult(true);
    return;
  }
  fetch("/api/validation/abbreviations", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({ fieldName, value })
  })
    .then((response) => response.json())
    .then((data) => {
      // data.ok === true means the value is acceptable
      this.returnResult(!!data.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isAbbreviationAcceptable",
  func: isAbbreviationAcceptable,
  isAsync: true
});
```

Add expression validators to your survey JSON, for example: `"expression": "isAbbreviationAcceptable('location', {location})"`. Refer to the JSON schema in the Code tab for more examples.

## Related Demos

- [Server-Side Form Validation Using Expressions](/form-library/examples/javascript-async-form-validation/)
- [Server-Side Form Validation Using an Event](/form-library/examples/javascript-server-side-form-validation/)
- [Detect Mis-Keyed Form Entries](/form-library/examples/detect-miskeyed-form-entries/)
- [Detect Duplicate Form Records](/form-library/examples/detect-duplicate-form-records/)

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Clinical Intake",
  "description": "Try abbreviations such as HR, NYC, BP, approx., or MS. Safe department terms auto-expand as you type; other fields use async expression validators against a terminology dictionary.",
  "checkErrorsMode": "onValueChanged",
  "completeText": "Submit Intake",
  "pages": [
    {
      "name": "intake",
      "elements": [
        {
          "type": "text",
          "name": "department",
          "title": "Department",
          "description": "Safe business abbreviations auto-expand as you type (try HR or Dept).",
          "placeholder": "e.g. HR"
        },
        {
          "type": "text",
          "name": "location",
          "title": "Clinic location",
          "description": "Known place abbreviations are checked via an async expression validator (try NYC).",
          "placeholder": "e.g. NYC",
          "validators": [
            {
              "type": "expression",
              "text": "This looks like an abbreviation. Prefer the full place name (for example, New York City instead of NYC).",
              "expression": "isAbbreviationAcceptable('location', {location})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "comment",
          "name": "clinicalNotes",
          "title": "Clinical notes",
          "description": "Free-text abbreviations are detected asynchronously (try \"BP elevated\" or \"Dx: HTN\").",
          "placeholder": "e.g. BP elevated; Dx: HTN; Rx pending",
          "validators": [
            {
              "type": "expression",
              "text": "Abbreviations detected in the notes. Prefer full terminology (for example, Blood Pressure instead of BP).",
              "expression": "isAbbreviationAcceptable('clinicalNotes', {clinicalNotes})",
              "notificationType": "warning"
            }
          ]
        },
        {
          "type": "text",
          "name": "condition",
          "title": "Primary condition / code",
          "description": "Ambiguous or Do Not Use abbreviations are flagged (try \"MS\").",
          "placeholder": "e.g. MS",
          "validators": [
            {
              "type": "expression",
              "text": "This abbreviation is ambiguous or on a Do Not Use list (for example, MS). Enter the full approved term.",
              "expression": "isAbbreviationAcceptable('condition', {condition})",
              "notificationType": "warning"
            }
          ]
        }
      ]
    }
  ]
}
;
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";
import { registerFunction } from "survey-core";


// Async expression validators + client-side auto-expand for safe abbreviations.
// Demo uses an in-memory dictionary; see the Documentation tab to connect your own API.

const ABBREVIATION_DICTIONARY = [
  { abbr: "BP", expansion: "Blood Pressure", autoExpand: false },
  { abbr: "DOB", expansion: "Date of Birth", autoExpand: false },
  { abbr: "Rx", expansion: "Prescription", autoExpand: false },
  { abbr: "Dx", expansion: "Diagnosis", autoExpand: false },
  { abbr: "HTN", expansion: "Hypertension", autoExpand: false },
  { abbr: "NYC", expansion: "New York City", autoExpand: false },
  { abbr: "Dept", expansion: "Department", autoExpand: true },
  { abbr: "HR", expansion: "Human Resources", autoExpand: true },
  { abbr: "Qty", expansion: "Quantity", autoExpand: true },
  { abbr: "approx", expansion: "approximately", autoExpand: false },
  { abbr: "approx.", expansion: "approximately", autoExpand: false },
  { abbr: "Intl", expansion: "International", autoExpand: false },
  { abbr: "ECG", expansion: "Electrocardiogram", autoExpand: false },
  {
    abbr: "MS",
    expansion: null,
    doNotUse: true,
    meanings: ["Multiple Sclerosis", "Morphine Sulfate", "Mitral Stenosis"]
  }
];

function normalizeToken(token) {
  return String(token || "").trim();
}

function dictionaryKey(abbr) {
  return normalizeToken(abbr).replace(/\.$/, "").toLowerCase();
}

function findDictionaryEntry(token) {
  const raw = normalizeToken(token);
  if (!raw) return null;
  const key = dictionaryKey(raw);
  return ABBREVIATION_DICTIONARY.find((entry) => {
    return dictionaryKey(entry.abbr) === key ||
      normalizeToken(entry.abbr).toLowerCase() === raw.toLowerCase();
  }) || null;
}

function extractTokens(text) {
  return String(text || "")
    .split(/[\s,;:/]+/)
    .map(normalizeToken)
    .filter(Boolean);
}

function findAbbreviationsInText(text) {
  const found = [];
  const seen = {};

  extractTokens(text).forEach((token) => {
    const entry = findDictionaryEntry(token);
    if (!entry) return;
    const key = dictionaryKey(entry.abbr);
    if (seen[key]) return;
    seen[key] = true;
    found.push(entry);
  });

  const whole = findDictionaryEntry(text);
  if (whole && !seen[dictionaryKey(whole.abbr)]) {
    found.push(whole);
  }

  return found;
}

function fieldHasAbbreviationIssue(name, value) {
  if (!value) return false;

  if (name !== "clinicalNotes") {
    const exact = findDictionaryEntry(value);
    if (exact) {
      if (exact.doNotUse) return true;
      if (exact.autoExpand && name === "department") return false;
      if (exact.expansion) return true;
    }
  }

  const matches = findAbbreviationsInText(value);
  if (!matches.length) return false;
  if (matches.some((entry) => entry.doNotUse)) return true;
  if (name === "clinicalNotes") {
    return matches.some((entry) => entry.expansion);
  }
  return !!matches[0].expansion;
}

// In-demo async check (replace with fetch to your terminology API in production).
function mockValidationApi(fieldName, value) {
  return new Promise((resolve) => {
    setTimeout(() => {
      resolve({ ok: !fieldHasAbbreviationIssue(fieldName, value) });
    }, 450);
  });
}

// Expression validator: returns true when the value is clear of abbreviation issues.
function isAbbreviationAcceptable([fieldName, value]) {
  if (!value) {
    this.returnResult(true);
    return;
  }

  mockValidationApi(fieldName, value)
    .then((result) => {
      this.returnResult(!!result.ok);
    })
    .catch(() => {
      this.returnResult(false);
    });
}

registerFunction({
  name: "isAbbreviationAcceptable",
  func: isAbbreviationAcceptable,
  isAsync: true
});

function autoExpandAbbreviations(sender, options) {
  if (options.name !== "department") {
    return;
  }

  const entry = findDictionaryEntry(options.value);
  if (!entry || !entry.autoExpand || !entry.expansion) {
    return;
  }

  if (normalizeToken(options.value).toLowerCase() === entry.expansion.toLowerCase()) {
    return;
  }

  sender.setValue(options.name, entry.expansion);
}

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onValueChanged.add(autoExpandAbbreviations);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/detect-abbreviations-in-form-entries/vanillajs.md)
